/* Tabela SEQNUMELOCA: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela SEQNUMELOCA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela SEQNUMELOCA utilizando a tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_SEQNUMELOCA' AND
                 TYPE = 'TR' 		                AND
	              U.UID = O.UID                   AND
	              U.NAME = USER)

DROP TRIGGER LOG_GER_SEQNUMELOCA
GO


CREATE TRIGGER LOG_GER_SEQNUMELOCA
ON SEQNUMELOCA
FOR INSERT, UPDATE, DELETE
AS

   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(300);
   DECLARE  @V_DTOPER       DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO       VARCHAR(1);

   DECLARE  @V_CDCTRLNUMENF_OLD VARCHAR(10);
   DECLARE  @V_CDLOCALEMIS_OLD  VARCHAR(4);
   DECLARE  @V_NRNFINICIAL_OLD  VARCHAR(7);
   DECLARE  @V_NRNFFINAL_OLD    VARCHAR(7);
   DECLARE  @V_DTLIBEFAIXNF_OLD DATETIME;
   DECLARE  @V_NRCDFRINI_OLD    VARCHAR(10);
   DECLARE  @V_NRCDFRFIM_OLD    VARCHAR(10);

   DECLARE  @V_CDCTRLNUMENF_NEW VARCHAR(10);
   DECLARE  @V_CDLOCALEMIS_NEW  VARCHAR(4);
   DECLARE  @V_NRNFINICIAL_NEW  VARCHAR(7);
   DECLARE  @V_NRNFFINAL_NEW    VARCHAR(7);
   DECLARE  @V_DTLIBEFAIXNF_NEW DATETIME;
   DECLARE  @V_NRCDFRINI_NEW    VARCHAR(10);
   DECLARE  @V_NRCDFRFIM_NEW    VARCHAR(10);


BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
         CDCTRLNUMENF,
         CDLOCALEMIS,
         NRNFINICIAL,
         NRNFFINAL,
         DTLIBEFAIXNF,
         NRCDFRINI,
         NRCDFRFIM,

         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
   FROM
      DELETED
   WHERE
      CDCTRLNUMENF+CDLOCALEMIS+NRNFINICIAL  NOT IN (SELECT CDCTRLNUMENF+CDLOCALEMIS+NRNFINICIAL FROM INSERTED)
   UNION ALL

   SELECT
     'U' IDCOMANDO,
         DELETED.CDCTRLNUMENF,
         DELETED.CDLOCALEMIS,
         DELETED.NRNFINICIAL,
         DELETED.NRNFFINAL,
         DELETED.DTLIBEFAIXNF,
         DELETED.NRCDFRINI,
         DELETED.NRCDFRFIM,
         INSERTED.CDCTRLNUMENF,
         INSERTED.CDLOCALEMIS,
         INSERTED.NRNFINICIAL,
         INSERTED.NRNFFINAL,
         INSERTED.DTLIBEFAIXNF,
         INSERTED.NRCDFRINI,
         INSERTED.NRCDFRFIM

   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDCTRLNUMENF  = DELETED.CDCTRLNUMENF  AND
      INSERTED.CDLOCALEMIS   = DELETED.CDLOCALEMIS   AND
      INSERTED.NRNFINICIAL   = DELETED.NRNFINICIAL
   UNION ALL

   SELECT
     'I' IDCOMANDO,

         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         CDCTRLNUMENF,
         CDLOCALEMIS,
         NRNFINICIAL,
         NRNFFINAL,
         DTLIBEFAIXNF,
         NRCDFRINI,
         NRCDFRFIM
    FROM
      INSERTED
    WHERE
       CDCTRLNUMENF+CDLOCALEMIS+NRNFINICIAL NOT IN (SELECT CDCTRLNUMENF+CDLOCALEMIS+NRNFINICIAL FROM DELETED);

    OPEN C_CURSOR;
    FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                  @V_CDCTRLNUMENF_OLD,
                                  @V_CDLOCALEMIS_OLD,
                                  @V_NRNFINICIAL_OLD,
                                  @V_NRNFFINAL_OLD,
                                  @V_DTLIBEFAIXNF_OLD,
                                  @V_NRCDFRINI_OLD,
                                  @V_NRCDFRFIM_OLD,

                                  @V_CDCTRLNUMENF_NEW,
                                  @V_CDLOCALEMIS_NEW,
                                  @V_NRNFINICIAL_NEW,
                                  @V_NRNFFINAL_NEW,
                                  @V_DTLIBEFAIXNF_NEW,
                                  @V_NRCDFRINI_NEW,
                                  @V_NRCDFRFIM_NEW;

    WHILE (@@FETCH_STATUS = 0) BEGIN
       IF @V_ID_COMANDO = 'D' BEGIN
          IF @V_CDCTRLNUMENF_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + 'Cod=' + @V_CDCTRLNUMENF_OLD;
          END;

          IF @V_CDLOCALEMIS_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' LocalEmis=' + @V_CDLOCALEMIS_OLD;
          END;

          IF @V_CDCTRLNUMENF_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + 'Cod=' + @V_CDCTRLNUMENF_OLD;
          END;

          IF @V_NRNFINICIAL_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' NrNfInicial=' + @V_NRNFINICIAL_OLD;
          END;

          IF @V_NRNFFINAL_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + 'NrNfFinal=' + @V_NRNFFINAL_OLD;
          END;

          IF @V_DTLIBEFAIXNF_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' DtLiberaFaixa=' + CONVERT(VARCHAR,@V_DTLIBEFAIXNF_OLD);
          END;

          IF @V_NRCDFRINI_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + 'NrCdFrIni=' + @V_NRCDFRINI_OLD;
          END;

          IF @V_NRCDFRFIM_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' NrCdFrFim=' + @V_NRCDFRFIM_OLD;
          END;

          SET @V_TIPO         = '3';
          SET @V_ITPESQ       = @V_CDCTRLNUMENF_OLD+@V_CDLOCALEMIS_OLD+@V_NRNFINICIAL_OLD;
       END
       ELSE
          IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
             IF (@V_CDCTRLNUMENF_OLD <> @V_CDCTRLNUMENF_NEW)  OR
                (@V_CDLOCALEMIS_OLD  <> @V_CDLOCALEMIS_NEW)   OR
                (@V_NRNFINICIAL_OLD  <> @V_NRNFINICIAL_NEW)   OR
                (@V_NRNFFINAL_OLD    <> @V_NRNFFINAL_NEW)     OR
                (ISNULL(@V_DTLIBEFAIXNF_NEW, GETDATE()) <> ISNULL(@V_DTLIBEFAIXNF_OLD,GETDATE())) OR
                (ISNULL(@V_NRCDFRINI_NEW,'!') <> ISNULL(@V_NRCDFRINI_OLD, '!')) OR
                (ISNULL(@V_NRCDFRFIM_NEW,'!') <> ISNULL(@V_NRCDFRFIM_OLD, '!')) BEGIN

                SET @V_DESC = @V_DESC + ' LocalEmis=' + @V_CDLOCALEMIS_NEW;
                SET @V_DESC = @V_DESC + 'Cod=' + @V_CDCTRLNUMENF_NEW;
                SET @V_DESC = @V_DESC + ' NrNfInicial=' + @V_NRNFINICIAL_NEW;
                SET @V_DESC = @V_DESC + 'NrNfFinal=' + @V_NRNFFINAL_NEW;
                SET @V_DESC = @V_DESC + ' DtLiberaFaixa=' + CONVERT(VARCHAR,@V_DTLIBEFAIXNF_NEW);
                SET @V_DESC = @V_DESC + 'NrCdFrIni=' + @V_NRCDFRINI_NEW;
                SET @V_DESC = @V_DESC + ' NrCdFrFim=' + @V_NRCDFRFIM_NEW;

                SET @V_TIPO         = '2';
                SET @V_ITPESQ       = @V_CDCTRLNUMENF_OLD+@V_CDLOCALEMIS_OLD + @V_NRNFINICIAL_OLD;
             END;
          END
          ELSE BEGIN
             SET @V_TIPO         = '1';
             SET @V_ITPESQ       = @V_CDCTRLNUMENF_NEW+@V_CDLOCALEMIS_NEW+@V_NRNFINICIAL_NEW;
          END;
          IF @V_CDCTRLNUMENF_NEW IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + 'Cod=' + @V_CDCTRLNUMENF_NEW;
          END;

          IF @V_CDLOCALEMIS_NEW IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' LocalEmis=' + @V_CDLOCALEMIS_NEW;
          END;

          IF @V_CDCTRLNUMENF_NEW IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + 'Cod=' + @V_CDCTRLNUMENF_NEW;
          END;

          IF @V_NRNFINICIAL_NEW IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' NrNfInicial=' + @V_NRNFINICIAL_NEW;
          END;

          IF @V_NRNFFINAL_NEW IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + 'NrNfFinal=' + @V_NRNFFINAL_NEW;
          END;

          IF @V_DTLIBEFAIXNF_NEW IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' DtLiberaFaixa=' + CONVERT(VARCHAR,@V_DTLIBEFAIXNF_NEW);
          END;

          IF @V_NRCDFRINI_NEW IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + 'NrCdFrIni=' + @V_NRCDFRINI_NEW;
          END;

          IF @V_NRCDFRFIM_NEW IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' NrCdFrFim=' + @V_NRCDFRFIM_NEW;
          END;
          IF @V_TIPO <> '0' BEGIN
             EXEC NMUSUARIO @V_USUARIO;
             IF NOT @V_DESC IS NULL BEGIN
                IF NOT @V_USUARIO IS NULL BEGIN
                   SET @V_DTOPER = GETDATE();

                   INSERT INTO LOGOPERA
                      (NMTABELA,   DTOPERACAO, NMRESPOPER,
                       IDTIPOOPER, CDPESQITEM, DSOPERACAO)
                   VALUES
                      ('SEQNUMELOCA',  @V_DTOPER, @V_USUARIO,
                       @V_TIPO,      @V_ITPESQ, @V_DESC);
                END;
             END;
          END;
          FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                        @V_CDCTRLNUMENF_OLD,
                                        @V_CDLOCALEMIS_OLD,
                                        @V_NRNFINICIAL_OLD,
                                        @V_NRNFFINAL_OLD,
                                        @V_DTLIBEFAIXNF_OLD,
                                        @V_NRCDFRINI_OLD,
                                        @V_NRCDFRFIM_OLD,

                                        @V_CDCTRLNUMENF_NEW,
                                        @V_CDLOCALEMIS_NEW,
                                        @V_NRNFINICIAL_NEW,
                                        @V_NRNFFINAL_NEW,
                                        @V_DTLIBEFAIXNF_NEW,
                                        @V_NRCDFRINI_NEW,
                                        @V_NRCDFRFIM_NEW;
    END;
    CLOSE      C_CURSOR;
    DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_SEQNUMELOCA','4.11.105';
GO



