-- ============================================================
--   Procedure para incluso de Dados na Tabela Relat_MoviEst
-- ============================================================
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'GRAVA_RELAT_MOVIEST'  AND
	        TYPE = 'P' 			             AND
	        U.UID = O.UID             	    AND
	        U.NAME = USER)

  DROP PROCEDURE GRAVA_RELAT_MOVIEST
  GO

CREATE PROCEDURE GRAVA_RELAT_MOVIEST @P_CDFILIAL      VARCHAR(04),
                                     @P_CDPRODUTO     VARCHAR(20),
                                     @P_NRLOTEESTQ    VARCHAR(20),
                                     @P_NRSUBLOTE     VARCHAR(04),
                                     @P_DTLANCAMEN    DATETIME   ,
                                     @P_IDTIPOLANC    VARCHAR(01),
                                     @P_CDFILLANC     VARCHAR(04),
                                     @P_NRLANCAMEN    VARCHAR(10),
                                     @P_NRSEQULANC    VARCHAR(04),
                                     @P_QTDEESTO      DOUBLE PRECISION,
                                     @P_CUSTMED       DOUBLE PRECISION,
                                     @P_CUSTESTO      DOUBLE PRECISION,
                                     @P_QTLANCAMEN    DOUBLE PRECISION,
                                     @P_CUSTBRUT      DOUBLE PRECISION,
                                     @P_CUSTMEES      DOUBLE PRECISION,
                                     @P_CUSTMEBR      DOUBLE PRECISION,
                                     @P_IDALTCMEDMV   VARCHAR(01),
                                     @P_QTLANCTOEST   DOUBLE PRECISION,
                                     @P_VRLANCTOEST   DOUBLE PRECISION,
                                     @P_VRLANCTOBRUT  DOUBLE PRECISION,
                                     @P_IDORDEMCLC    VARCHAR(01),
                                     @P_NVPROD        VARCHAR(20),
                                     @P_NMPRODUTO     VARCHAR(50),
                                     @P_SGUNIDADE     VARCHAR(10),
                                     @P_NRRELATMOVI   VARCHAR(10),
                                     @P_VRUNILANCTO   DOUBLE PRECISION,
                                     @P_VRTOTLANCTO   DOUBLE PRECISION,
                                     @P_VRTOTALANTE   DOUBLE PRECISION,
                                     @P_QTTOTALANTE   DOUBLE PRECISION,
                                     @P_CDALMOXARIFE  VARCHAR(06),
                                     @P_CDLOCALESTOQ  VARCHAR(06),
                                     @P_VRCUSTENTRME  DOUBLE PRECISION,
                                     @P_CDTIPORETIME  VARCHAR(02),
                                     @P_NMTIPORETIME  VARCHAR(40),
                                     @P_IDENTRSAIDME  VARCHAR(01),
                                     @P_CDTIPOOPERME  VARCHAR(02),
                                     @P_VRCUSTLOGLME  DOUBLE PRECISION,
                                     @P_VRCUSTSEGLME  DOUBLE PRECISION,
                                     @P_VRCUSTLOGEME  DOUBLE PRECISION,
                                     @P_VRCUSTSEGEME  DOUBLE PRECISION,
                                     @P_VRPESOBRUTME  DOUBLE PRECISION

AS
   DECLARE @V_NRNOTAFISC     VARCHAR(20);
BEGIN
   SET @V_NRNOTAFISC = NULL;

   IF @P_IDTIPOLANC IN ('2','4','5') BEGIN
      SELECT @V_NRNOTAFISC = N.NRNOTAFISC
        FROM LANCTOESTOQ L, NOTAFISCAL N
       WHERE L.CDFILIAL   = @P_CDFILLANC
         AND L.NRLANCESTQ = @P_NRLANCAMEN
         AND N.CDFILIAL   = L.CDFILIAL
         AND N.NRLANCTONF = L.NRLANCTONF;
   END;

   INSERT INTO RELAT_MOVIEST
   (CDFILIMOVIEST, CDPRODMOVIEST, NRLOTEESTQME,  NRSUBLOTEME,   DTLANCMOVIEST,
    IDTIPOMOVIEST, CDFILLANCMEST, NRLANCMOVIEST, NRSEQUMOVIEST, QTDEMOVIEST,   VRCUSTMEDI,
    VRCUSTMOVIEST, QTLANCAMENTO,  VRCUSTBRUT,    VRCUSTMEES,    VRCUSTMEBR,
    IDALTCMEDMOV,  QTLANCMOVIEST, VRLANCMOVIEST, VRBRUTMOVIEST, IDORDEMCALC,
    CDTOTMOVIEST,  NMPRODMOVIEST, SGUNIDMOVI,    NRRELATMOVI,   VRUNILANCEST,
    VRTOTLANCEST,  VRTOTALANT,    QTTOTALANT,    CDALMOXARIRM,  CDLOCALESTRM,
    VRCUSTENTRME,  CDTIPORETIME,  NMTIPORETIME,  IDENTRSAIDME,  CDTIPOOPERME,
    VRCUSTLOGLME,  VRCUSTSEGLME,  VRCUSTLOGEME,  VRCUSTSEGEME,
    VRPESOBRUTME,  NRNOTAFISCEST)
   VALUES
   (@P_CDFILIAL,     @P_CDPRODUTO,    @P_NRLOTEESTQ,   @P_NRSUBLOTE,    @P_DTLANCAMEN,
    @P_IDTIPOLANC,   @P_CDFILLANC,    @P_NRLANCAMEN,   @P_NRSEQULANC,   @P_QTDEESTO,
    @P_CUSTMED,      @P_CUSTESTO,     @P_QTLANCAMEN,   @P_CUSTBRUT,     @P_CUSTMEES,
    @P_CUSTMEBR,     @P_IDALTCMEDMV,  @P_QTLANCTOEST,  @P_VRLANCTOEST,  @P_VRLANCTOBRUT,
    @P_IDORDEMCLC,   @P_NVPROD,       @P_NMPRODUTO,    @P_SGUNIDADE,    @P_NRRELATMOVI,
    @P_VRUNILANCTO,  @P_VRTOTLANCTO,  @P_VRTOTALANTE,  @P_QTTOTALANTE,  @P_CDALMOXARIFE,
    @P_CDLOCALESTOQ, @P_VRCUSTENTRME, @P_CDTIPORETIME, @P_NMTIPORETIME, @P_IDENTRSAIDME,
    @P_CDTIPOOPERME, @P_VRCUSTLOGLME, @P_VRCUSTSEGLME, @P_VRCUSTLOGEME, @P_VRCUSTSEGEME,
    @P_VRPESOBRUTME, @V_NRNOTAFISC);
END;

GO


-- VERSAO --
EXEC ATUVEROBJ 'GRAVA_RELAT_MOVIEST','6.35.014';
GO

