var configParams = require("./config/configParams.js");

exports.config = {
    rootElement: 'html',
    framework: 'jasmine2',
    seleniumAddress: configParams.seleniumAddress,
    params: {
        applicationUrl: configParams.functionalTest
    },

    restartBrowserBetweenTests: false,
    capabilities: {
        browserName: 'chrome',
        chromeOptions: {
            args: ['disable-popup-blocking', 'test-type', 'disable-extensions', 'disable-web-security', 'incognito']
        },
        proxy: {
            proxyType: 'manual',
            httpProxy: configParams.httpProxy
        }
    },

    plugins: [{
        package: 'protractor-screenshoter-plugin',
        screenshotPath: './REPORTS/e2e',
        screenshotOnExpect: 'failure+success',
        screenshotOnSpec: 'none',
        withLogs: true,
        writeReportFreq: 'asap',
        imageToAscii: 'none',
        clearFoldersBeforeTest: true
    }],

    specs: [
        'specs/login.spec.js',
        'specs/**/*.spec.js'
    ],

    allScriptsTimeout: 200000, // 3 minutos de timeout
    getPageTimeout: 150000, // 2,5 minutos de timeout para carregar o angular
    jasmineNodeOpts: {
        defaultTimeoutInterval: 300000, // 5 minutos de timeout
    },

    onPrepare: function () {
        protractor.basePath = __dirname;
        // returning the promise makes protractor wait for the reporter config before executing tests
        return global.browser.getProcessedConfig().then(function (config) {
            //it is ok to be empty
        });
    }
};